from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, String, Boolean

Dudes_Py_V0_1_0 = CommandToolBuilder(tool="DUDes.py", base_command=["DUDes.py"], inputs=[ToolInput(tag="in_alignmentmapping_file_sam", input_type=File(optional=True), prefix="-s", doc=InputDocumentation(doc="Alignment/mapping file in SAM format. DUDes does not\ndepend on any specific read mapper, but it requires\nheader information (@SQ\nSN:gi|556555098|ref|NC_022650.1| LN:55956) and\nmismatch information (check -i)")), ToolInput(tag="in_database_file_output", input_type=File(optional=True), prefix="-d", doc=InputDocumentation(doc="Database file (output from DUDesDB [.npz])")), ToolInput(tag="in_sam_file_format", input_type=File(optional=True), prefix="-i", doc=InputDocumentation(doc="SAM file format ['nm': sam file with standard cigar\nstring plus NM flag (NM:i:[0-9]*) for mismatches count\n| 'ex': just the extended cigar string]. Default: 'nm'")), ToolInput(tag="in__threads_default", input_type=Int(optional=True), prefix="-t", doc=InputDocumentation(doc="# of threads. Default: 1")), ToolInput(tag="in_taxonomic_i_d", input_type=Int(optional=True), prefix="-x", doc=InputDocumentation(doc="Taxonomic Id used to start the analysis (1 = root).\nDefault: 1")), ToolInput(tag="in_keep_reads_percentile", input_type=Int(optional=True), prefix="-m", doc=InputDocumentation(doc="Keep reads up to this number/percentile of matches (0:\noff / 0-1: percentile / >=1: match count). Default: 0")), ToolInput(tag="in_minimum_numberpercentage_supporting", input_type=Int(optional=True), prefix="-a", doc=InputDocumentation(doc="Minimum number/percentage of supporting matches to\nconsider the reference (0: off / 0-1: percentage /\n>=1: read number). Default: 0.001")), ToolInput(tag="in_last_considered_rank", input_type=String(optional=True), prefix="-l", doc=InputDocumentation(doc="Last considered rank [superkingdom,phylum,class,order,\nfamily,genus,species,strain]. Default: 'species'")), ToolInput(tag="in_bin_size_percentile", input_type=Int(optional=True), prefix="-b", doc=InputDocumentation(doc="Bin size (0-1: percentile from the lengths of all\nreferences in the database / >=1: bp). Default: 0.25")), ToolInput(tag="in_output_prefix_stdout", input_type=String(optional=True), prefix="-o", doc=InputDocumentation(doc="Output prefix. Default: STDOUT")), ToolInput(tag="in_show_programs_number", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="show program's version number and exit"))], outputs=[ToolOutput(tag="out_database_file_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_database_file_output", type_hint=File()), doc=OutputDocumentation(doc="Database file (output from DUDesDB [.npz])"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Dudes_Py_V0_1_0().translate("wdl", allow_empty_container=True)

